"use strict";
var path = require("path");
var ts = require("typescript");
var file_util_1 = require("./file-util");
function findAndReadConfig(baseDir, _parseConfigHost, // for test
    _exists // for test
) {
    if (_parseConfigHost === void 0) { _parseConfigHost = ts.sys; }
    if (_exists === void 0) { _exists = file_util_1.exists; } // for test
    var configFileName = 'tsconfig.json';
    function loop(dir) {
        var parentPath = path.dirname(dir);
        // It is root directory if parent and current dirname are the same
        if (dir === parentPath) {
            return undefined;
        }
        var configPath = path.join(dir, configFileName);
        if (!_exists(configPath)) {
            return loop(parentPath);
        }
        var result = ts.readConfigFile(configPath, _parseConfigHost.readFile);
        return ts.parseJsonConfigFileContent(result.config, _parseConfigHost, dir, undefined, configPath);
    }
    return loop(baseDir);
}
exports.findAndReadConfig = findAndReadConfig;
